require 'singleton'

module Algorand
  class Configuration
    include Singleton
    attr_reader :algod_host, :indexer_host, :kmd_host

    DEFAULT_ALGOD_HOST='localhost:4001'
    DEFAUT_INDEXER_HOST='localhost:8980'
    DEFAULT_KMD_HOST='localhost:4002'

    def self.set_defaults
      instance.set_defaults
    end

    def initialize
      set_defaults
    end

    def configure(options)
      @algod_host = options[:algod_host]
      @indexer_host = options[:indexer_host]
      @kmd_host = options[:kmd_host]
    end

    private

    def set_defaults
      @algod_host = DEFAULT_ALGOD_HOST
      @indexer_host = DEFAUT_INDEXER_HOST
      @kmd_host = DEFAULT_KMD_HOST
    end
  end
end
